#!/bin/sh

APKG_PKG_DIR=/usr/local/AppCentral/photo-gallery
PG_CONFIG=${APKG_PKG_DIR}/application/config/photo_gallery.php

AVAHI_REGISTER=/usr/builtin/sbin/avahiregister

PG_PASSWD=$(sed -n "s/\$config\['db_password'\] = '\(.*\)';/\1/p" ${PG_CONFIG})

/bin/chown admin:administrators ${APKG_PKG_DIR}/application/session/
/bin/chown admin:administrators ${APKG_PKG_DIR}/application/upload/

case "$APKG_PKG_STATUS" in

	install)
		if [ x"${PG_PASSWD}" = x"_REPLACE_USER_PASSWD_" ]; then
			DB_PASSWORD=`echo $RANDOM | md5sum | awk '{print $1}'`
			sed -i -e "s?\$config\['db_password'\] = '[^']*'?\$config\['db_password'\] = '${DB_PASSWORD}'?" ${PG_CONFIG}
		fi
		;;
	upgrade)
		DB_PASSWORD=`cat ${APKG_TEMP_DIR}/passwd.db`

		if [ x"${PG_PASSWD}" != x"${DB_PASSWORD}" ]; then
			sed -i -e "s?\$config\['db_password'\] = '[^']*'?\$config\['db_password'\] = '${DB_PASSWORD}'?" ${PG_CONFIG}
		fi
		;;
	*)
		;;

esac

#backup user config
cp -R /volume1/.@tmp/user_config/ ${APKG_PKG_DIR}

# Register this service to avahi.
$AVAHI_REGISTER -reg pg %h _ASUSTOR_PG._tcp -2

#Register share folder
MACHINE_TYPE=`uname -m`
if [ ${MACHINE_TYPE} == 'x86_64' ]; then
	/usr/local/AppCentral/photo-gallery/asutil/bin/asutil_x64 -regappshare "PhotoGallery" 0
elif [ ${MACHINE_TYPE} == 'armv71' ]; then
	/usr/local/AppCentral/photo-gallery/asutil/bin/asutil_arm -regappshare "PhotoGallery" 0
else
	/usr/local/AppCentral/photo-gallery/asutil/bin/asutil_x86 -regappshare "PhotoGallery" 0
fi

exit 0
