<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); require_once('As_base.php'); define('FILE_SKIP', 0); define('FILE_RENAME', 1); define('FILE_OVERWRITE', 2); class As_filesystem extends As_base { private $file_exist_modes = array(FILE_SKIP, FILE_RENAME, FILE_OVERWRITE); private $copy_mode = FILE_RENAME; private $move_mode = FILE_RENAME; private $volume; public $error_msg = array(); public function __construct($params = NULL) { parent::__construct(); if (isset($params['copy_mode']) && $params['copy_mode']) { if (in_array($params['copy_mode'], $this->file_exist_modes, TRUE)) { $this->copy_mode = $params['copy_mode']; } } if (isset($params['move_mode']) && $params['move_mode']) { if (in_array($params['move_mode'], $this->file_exist_modes, TRUE)) { $this->move_mode = $params['move_mode']; } } $cmd = " /usr/builtin/sbin/shareprivilege -getabspath /PhotoGallery"; $volume_info = shell_exec($cmd); $this->volume = trim(str_replace("PhotoGallery","",$volume_info)); } private function _set_filename($filename) { if ( ! file_exists($filename)) { return $filename; } $path_parts = pathinfo($filename); for ($i = 1; $i < 1000; $i++) { $new_filename = $path_parts['dirname'] . DIRECTORY_SEPARATOR . $path_parts['filename'] . '_' . $i . '.' . $path_parts['extension']; if ( ! file_exists($new_filename)) { return $new_filename; } } } private function _copy($source, $dest) { $result = copy($source, $dest); if ($result) { $result &= chmod($dest, FILE_WRITE_MODE); } return $result; } private function _link($target, $link) { $result = link($target, $link); return $result; } public function copy($source, $dest) { if ( ! file_exists($source)) { return FALSE; } if ($this->copy_mode == FILE_SKIP && file_exists($dest)) { return FALSE; } elseif ($this->copy_mode == FILE_RENAME) { $dest = $this->_set_filename($dest); } elseif ($this->copy_mode == FILE_OVERWRITE) { if ($source == $dest) { return FALSE; } } $copy_func = '_copy'; return $this->$copy_func($source, $dest); } public function move($source, $dest) { if ( ! file_exists($source)) { return FALSE; } if ($source == $dest) { return FALSE; } if ($this->move_mode == FILE_SKIP && file_exists($dest)) { return FALSE; } elseif ($this->move_mode == FILE_RENAME) { $dest = $this->_set_filename($dest); } return rename($source, $dest); } public function move_upload_files($upload_dir, $dest_dir) { if ( ! file_exists($dest_dir)) { @mkdir($dest_dir, DIR_READ_MODE); } if ($fp = @opendir($upload_dir)) { $upload_dir = rtrim($upload_dir, DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR; $dest_dir = rtrim($dest_dir, DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR; while (FALSE !== ($file = readdir($fp))) { if ( ! trim($file, '.')) { continue; } if (is_file($upload_dir . $file)) { $this->move($upload_dir . $file, $dest_dir . $file); } } closedir($fp); } } private function _delete_file($filename) { $filename = str_replace("/share/",$this->volume, $filename); $cmd = " thumbnail -home ".addcslashes($filename, "\40..\51"); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "AS_filesystem thumb home 0 '.$cmd.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } $thumb_home = shell_exec($cmd); preg_match('/Path: (\[([\S]*)\])/', $thumb_home, $matches); $thumbs_dir = $matches[2]; if(strpos($thumbs_dir, $this->volume.".@thumbnail") === FALSE){ return FALSE; } if (!is_dir($thumbs_dir)) { return FALSE; } $dest = $this->volume.$this->web_config['trashcan']. DIRECTORY_SEPARATOR.basename($thumbs_dir); $cmd = " rm -rf ".$thumbs_dir; if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "'.$cmd.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } rename($thumbs_dir, $dest); $dest_ori = $this->volume.$this->web_config['trashcan']. DIRECTORY_SEPARATOR.basename($filename); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "AS_filesystem rename file 0 '.$dest_ori.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } return @rename($filename, $dest_ori); } private function _delete_dir($path) { $path = str_replace("/share/",$this->volume, $path); $path = rtrim($path, DIRECTORY_SEPARATOR); if ( ! $current_dir = @opendir($path)) { return FALSE; } while (FALSE !== ($filename = @readdir($current_dir))) { if ($filename != "." and $filename != "..") { $target = $path . DIRECTORY_SEPARATOR . $filename; if (is_dir($target)) { $this->_delete_dir($target); } else { $this->_delete_file($target); } } } @closedir($current_dir); if(strpos($path, $this->volume) === FALSE){ return FALSE; } $dest = $this->volume.$this->web_config['trashcan']. DIRECTORY_SEPARATOR.basename($path); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "rmdir '.$path.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } return @rename($path, $dest); } public function delete($path) { if ( ! file_exists($path)) { return FALSE; } if (is_file($path)) { return $this->_delete_file($path); } elseif (is_dir($path)) { return $this->_delete_dir($path); } } private function Sync_delete_file($filename,$fileinode) { $filename = str_replace("/share/",$this->volume, $filename); $cmd = " thumbnail -home ".addcslashes($filename, "\40..\51"); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "AS_filesystem thumb home 1 '.$cmd.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } $thumb_home = shell_exec($cmd); preg_match('/Path: (\[([\S]*)\])/', $thumb_home, $matches); $thumbs_dir = $matches[2]; if(strpos($thumbs_dir, $this->volume.".@thumbnail") === FALSE){ return FALSE; } if (!is_dir($thumbs_dir)) { return FALSE; } if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event " remove thumb dir '.$thumbs_dir.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } $this->_delete_dir($thumbs_dir); } public function Sync_delete($path,$fileinode) { if($path == null || $fileinode == null){ return FALSE; } if(strpos($path, $this->volume) === FALSE){ return FALSE; } if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "remove file '.$path.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } return $this->Sync_delete_file($path,$fileinode); } public function delete_only_thumbnail($path) { if($path == null) return FALSE; return $this->_delete_thumbnail_file($path); } private function _delete_thumbnail_file($filename) { $filename = str_replace("/share/",$this->volume, $filename); $cmd = " thumbnail -free ".addcslashes($filename, "\40..\51"); $rez = shell_exec($cmd); $tester = 'Status: [0,'; return (substr($rez, 0, strlen($tester)) === $tester); } } 