<?php defined('BASEPATH') OR exit('No direct script access allowed'); class Migration_Initial_Schema extends CI_Migration { private $db_tables = array( 'album' => 'albums', 'photo' => 'photos', 'tag' => 'tags', 'person' => 'persons', 'photo_tag' => 'photo_tags', 'photo_person' => 'photo_persons', 'photo_comment' => 'photo_comments', 'album_user' => 'album_users', 'smart_album' => 'smart_albums', 'share_link' => 'share_links', 'setting' => 'settings' ); private $db_enum = array( 'album_access' => array('Public', 'Password', 'Private'), 'display_mode' => array('Wall', 'Fixed'), 'photo_order' => array('UploadTime', 'PhotoTime', 'Name'), 'user_privilege' => array('Deny', 'Browse', 'Upload', 'Admin'), 'filter_cond' => array('Any', 'All'), 'album_type' => array('Album', 'SmartAlbum'), 'share_type' => array('Album', 'Photo', 'SmartAlbum'), 'status_type' => array('Idle', 'Resize', 'Rotote'), 'exif_orientation' => array( EO_1_NORMAL, EO_2_FLIP_HOR, EO_3_ROT_180, EO_4_FLIP_VRT, EO_5_ROT_90_CCW_FLIP_VRT, EO_6_ROT_90_CCW, EO_7_ROT_90_CW_FLIP_VRT, EO_8_ROT_90_CW ) ); private $db_schema = array(); private function _prepare_album_table() { $this->db_schema['album'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9' ), 'name' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'description' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'cover' => array( 'type' => 'INT', 'constraint' => '9', 'null' => TRUE ), 'level' => array( 'type' => 'INT', 'constraint' => '9' ), 'path' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'user_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'access' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['album_access']) . "'".")", 'default' => 'Private' ), 'passwd' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'create_time' => array( 'type' => 'DATETIME' ), 'update_time' => array( 'type' => 'DATETIME' ), '@primary_key' => 'id', '@key' => array('name', 'description') ); } private function _prepare_album_user_table() { $this->db_schema['album_user'] = array( 'album_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'user_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'display_mode' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['display_mode']) . "'".")", 'default' => 'Wall' ), 'photo_order' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['photo_order']) . "'".")", 'default' => 'Name' ), 'privilege' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['user_privilege']) . "'".")", 'default' => 'Deny' ), '@primary_key' => array('album_id', 'user_id') ); } private function _prepare_person_table() { $this->db_schema['person'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'name' => array( 'type' => 'VARCHAR', 'constraint' => '64' ), '@primary_key' => 'id' ); } private function _prepare_photo_table() { $this->db_schema['photo'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9' ), 'album_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'name' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'description' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'width' => array( 'type' => 'INT', 'constraint' => '9' ), 'height' => array( 'type' => 'INT', 'constraint' => '9' ), 'resize' => array( 'type' => 'INT', 'constraint' => '9', 'default' => '0' ), 'orientation' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['exif_orientation']) . "'".")", 'default' => EO_1_NORMAL ), 'status' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['status_type']) . "'".")", 'default' => 'Idle' ), 'photo_time' => array( 'type' => 'DATETIME' ), 'photo_mtime' => array( 'type' => 'DATETIME' ), 'upload_time' => array( 'type' => 'DATETIME' ), 'update_time' => array( 'type' => 'DATETIME' ), '@primary_key' => array('id', 'album_id'), '@key' => array('name', 'description') ); } private function _prepare_photo_comment_table() { $this->db_schema['photo_comment'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'album_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'photo_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'username' => array( 'type' => 'VARCHAR', 'constraint' => '64' ), 'email' => array( 'type' => 'VARCHAR', 'constraint' => '128', 'null' => TRUE ), 'message' => array( 'type' => 'TEXT' ), 'create_time' => array( 'type' => 'DATETIME' ), '@primary_key' => 'id' ); } private function _prepare_photo_person_table() { $this->db_schema['photo_person'] = array( 'album_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'photo_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'person_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'left' => array( 'type' => 'FLOAT' ), 'top' => array( 'type' => 'FLOAT' ), 'width' => array( 'type' => 'FLOAT' ), 'height' => array( 'type' => 'FLOAT' ), '@primary_key' => array('album_id', 'photo_id', 'person_id') ); } private function _prepare_photo_tag_table() { $this->db_schema['photo_tag'] = array( 'album_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'photo_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'tag_id' => array( 'type' => 'INT', 'constraint' => '9' ), '@primary_key' => array('album_id', 'photo_id', 'tag_id') ); } private function _prepare_setting_table() { $this->db_schema['setting'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'p_key' => array( 'type' => 'VARCHAR', 'constraint' => '32' ), 'p_value' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), '@primary_key' => 'id' ); } private function _prepare_share_link_table() { $this->db_schema['share_link'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'user_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'hash_code' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'share_type' => array( 'type' => 'ENUM', 'constraint' => "'" . implode("', '", $this->db_enum['share_type']) . "'" ), 'share_contents' => array( 'type' => 'TEXT' ), 'passwd' => array( 'type' => 'VARCHAR', 'constraint' => '64' ), 'active' => array( 'type' => 'BOOLEAN' ), 'expire_time' => array( 'type' => 'DATETIME' ), 'create_time' => array( 'type' => 'DATETIME' ), '@primary_key' => 'id' ); } private function _prepare_smart_album_table() { $this->db_schema['smart_album'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'user_id' => array( 'type' => 'INT', 'constraint' => '9' ), 'name' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'description' => array( 'type' => 'VARCHAR', 'constraint' => '128' ), 'keyword' => array( 'type' => 'VARCHAR', 'constraint' => '64' ), 'photo_date1' => array( 'type' => 'DATE', 'null' => TRUE ), 'photo_date2' => array( 'type' => 'DATE', 'null' => TRUE ), 'upload_date1' => array( 'type' => 'DATE', 'null' => TRUE ), 'upload_date2' => array( 'type' => 'DATE', 'null' => TRUE ), 'person_cond' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['filter_cond']) . "'".")", 'default' => 'Any' ), 'persons' => array( 'type' => 'TEXT' ), 'tag_cond' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['filter_cond']) . "'".")", 'default' => 'Any' ), 'tags' => array( 'type' => 'TEXT' ), 'display_mode' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['display_mode']) . "'".")", 'default' => 'Wall' ), 'photo_order' => array( 'type' => 'ENUM('."'" . implode("', '", $this->db_enum['photo_order']) . "'".")", 'default' => 'Name' ), '@primary_key' => 'id' ); } private function _prepare_tag_table() { $this->db_schema['tag'] = array( 'id' => array( 'type' => 'INT', 'constraint' => '9', 'auto_increment' => TRUE ), 'name' => array( 'type' => 'VARCHAR', 'constraint' => '64' ), '@primary_key' => 'id' ); } public function up() { foreach ($this->db_tables as $table_key => $table_name) { $func = '_prepare_' . $table_key . '_table'; $this->$func(); } foreach ($this->db_schema as $table_key => $fields) { if ($this->db->table_exists($this->db_tables[$table_key])) { continue; } if (isset($fields['@primary_key'])) { $this->dbforge->add_key($fields['@primary_key'], TRUE); unset($fields['@primary_key']); } if (isset($fields['@key'])) { $this->dbforge->add_key($fields['@key']); unset($fields['@key']); } $this->dbforge->add_field($fields); $this->dbforge->create_table($this->db_tables[$table_key], TRUE); } } public function down() { } } 