<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); class Smart_album_model extends MY_Model { private $user_id; public function __construct() { parent::__construct(); $this->load->database(); } public function initialize($params = NULL) { if (isset($params['user_id']) && $params['user_id']) { $this->user_id = $params['user_id']; } } public function lists($keyword = '', $start = NULL, $limit = NULL) { $this->db->select('id, name'); $this->db->like('name', $keyword); $this->db->or_like('description', $keyword); $this->db->order_by('name', 'asc'); $query = $this->db->get($this->db_tables['smart_album'], $limit, $start); $result = array( 'total' => $this->count_last_results(), 'data' => $query->result() ); return $result; } public function get($album_id) { $this->db->where('id', $album_id); $query = $this->db->get($this->db_tables['smart_album']); $row = $query->row(); if (empty($row)) { return FALSE; } $row->persons = unserialize($row->persons); $row->tags = unserialize($row->tags); return $row; } public function get_album_ids($album_id) { if ( 0 != strcasecmp($album_id, 'all')) { return array_filter(explode(',', $album_id), 'is_numeric'); } $result = $this->lists(); if ($result === FALSE) { return NULL; } $album_ids = array(); foreach ($result as $album) { $album_ids[] = $album->id; } return $album_ids; } public function get_photos($album_id, $start = NULL, $limit = NULL) { $data = $this->get($album_id); if ($data === FALSE) { return FALSE; } $this->load->model('search_model'); $search_photos = $this->search_model->search((array)$data, $start, $limit); return $search_photos; } public function add($data) { $this->db->where('name', $data['name']); $count = $this->db->count_all_results($this->db_tables['smart_album']); if ($count != 0) { return FALSE; } $data['persons'] = serialize($data['persons']); $data['tags'] = serialize($data['tags']); $this->db->insert($this->db_tables['smart_album'], $data); $album_id = $this->db->insert_id(); return $album_id; } public function update($album_id, $data) { $data['persons'] = serialize($data['persons']); $data['tags'] = serialize($data['tags']); $this->db->where('id', $album_id); $this->db->update($this->db_tables['smart_album'], $data); return TRUE; } public function update_display_mode($album_id, $display_mode, $photo_order) { $data = array( 'display_mode' => $display_mode, 'photo_order' => $photo_order ); $this->db->where('id', $album_id); $this->db->where('user_id', $this->user_id); $this->db->update($this->db_tables['smart_album'], $data); } public function delete($album_ids) { $this->db->where_in('id', $album_ids); $this->db->delete($this->db_tables['smart_album']); } } 